# coding: utf-8

"""
    metal-api

    API to manage and control plane resources like machines, switches, operating system images, machine sizes, networks, IP addresses and more  # noqa: E501

    OpenAPI spec version: v0.40.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six


class V1NetworkAllocateRequest(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'addressfamily': 'str',
        'description': 'str',
        'destinationprefixes': 'list[str]',
        'labels': 'dict(str, str)',
        'length': 'dict(str, int)',
        'name': 'str',
        'nat': 'bool',
        'parentnetworkid': 'str',
        'partitionid': 'str',
        'projectid': 'str',
        'shared': 'bool'
    }

    attribute_map = {
        'addressfamily': 'addressfamily',
        'description': 'description',
        'destinationprefixes': 'destinationprefixes',
        'labels': 'labels',
        'length': 'length',
        'name': 'name',
        'nat': 'nat',
        'parentnetworkid': 'parentnetworkid',
        'partitionid': 'partitionid',
        'projectid': 'projectid',
        'shared': 'shared'
    }

    def __init__(self, addressfamily=None, description=None, destinationprefixes=None, labels=None, length=None, name=None, nat=None, parentnetworkid=None, partitionid=None, projectid=None, shared=None):  # noqa: E501
        """V1NetworkAllocateRequest - a model defined in Swagger"""  # noqa: E501

        self._addressfamily = None
        self._description = None
        self._destinationprefixes = None
        self._labels = None
        self._length = None
        self._name = None
        self._nat = None
        self._parentnetworkid = None
        self._partitionid = None
        self._projectid = None
        self._shared = None
        self.discriminator = None

        self.addressfamily = addressfamily
        if description is not None:
            self.description = description
        if destinationprefixes is not None:
            self.destinationprefixes = destinationprefixes
        if labels is not None:
            self.labels = labels
        self.length = length
        if name is not None:
            self.name = name
        if nat is not None:
            self.nat = nat
        self.parentnetworkid = parentnetworkid
        if partitionid is not None:
            self.partitionid = partitionid
        if projectid is not None:
            self.projectid = projectid
        if shared is not None:
            self.shared = shared

    @property
    def addressfamily(self):
        """Gets the addressfamily of this V1NetworkAllocateRequest.  # noqa: E501

        the addressfamily to allocate a child network defaults. If not specified, the child network inherits the addressfamilies from the parent.  # noqa: E501

        :return: The addressfamily of this V1NetworkAllocateRequest.  # noqa: E501
        :rtype: str
        """
        return self._addressfamily

    @addressfamily.setter
    def addressfamily(self, addressfamily):
        """Sets the addressfamily of this V1NetworkAllocateRequest.

        the addressfamily to allocate a child network defaults. If not specified, the child network inherits the addressfamilies from the parent.  # noqa: E501

        :param addressfamily: The addressfamily of this V1NetworkAllocateRequest.  # noqa: E501
        :type: str
        """
        if addressfamily is None:
            raise ValueError("Invalid value for `addressfamily`, must not be `None`")  # noqa: E501
        allowed_values = ["IPv4", "IPv6"]  # noqa: E501
        if addressfamily not in allowed_values:
            raise ValueError(
                "Invalid value for `addressfamily` ({0}), must be one of {1}"  # noqa: E501
                .format(addressfamily, allowed_values)
            )

        self._addressfamily = addressfamily

    @property
    def description(self):
        """Gets the description of this V1NetworkAllocateRequest.  # noqa: E501

        a description for this entity  # noqa: E501

        :return: The description of this V1NetworkAllocateRequest.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this V1NetworkAllocateRequest.

        a description for this entity  # noqa: E501

        :param description: The description of this V1NetworkAllocateRequest.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def destinationprefixes(self):
        """Gets the destinationprefixes of this V1NetworkAllocateRequest.  # noqa: E501

        the destination prefixes of this network  # noqa: E501

        :return: The destinationprefixes of this V1NetworkAllocateRequest.  # noqa: E501
        :rtype: list[str]
        """
        return self._destinationprefixes

    @destinationprefixes.setter
    def destinationprefixes(self, destinationprefixes):
        """Sets the destinationprefixes of this V1NetworkAllocateRequest.

        the destination prefixes of this network  # noqa: E501

        :param destinationprefixes: The destinationprefixes of this V1NetworkAllocateRequest.  # noqa: E501
        :type: list[str]
        """

        self._destinationprefixes = destinationprefixes

    @property
    def labels(self):
        """Gets the labels of this V1NetworkAllocateRequest.  # noqa: E501

        free labels that you associate with this network.  # noqa: E501

        :return: The labels of this V1NetworkAllocateRequest.  # noqa: E501
        :rtype: dict(str, str)
        """
        return self._labels

    @labels.setter
    def labels(self, labels):
        """Sets the labels of this V1NetworkAllocateRequest.

        free labels that you associate with this network.  # noqa: E501

        :param labels: The labels of this V1NetworkAllocateRequest.  # noqa: E501
        :type: dict(str, str)
        """

        self._labels = labels

    @property
    def length(self):
        """Gets the length of this V1NetworkAllocateRequest.  # noqa: E501

        the bitlen of the prefix to allocate, defaults to defaultchildprefixlength of super prefix  # noqa: E501

        :return: The length of this V1NetworkAllocateRequest.  # noqa: E501
        :rtype: dict(str, int)
        """
        return self._length

    @length.setter
    def length(self, length):
        """Sets the length of this V1NetworkAllocateRequest.

        the bitlen of the prefix to allocate, defaults to defaultchildprefixlength of super prefix  # noqa: E501

        :param length: The length of this V1NetworkAllocateRequest.  # noqa: E501
        :type: dict(str, int)
        """
        if length is None:
            raise ValueError("Invalid value for `length`, must not be `None`")  # noqa: E501

        self._length = length

    @property
    def name(self):
        """Gets the name of this V1NetworkAllocateRequest.  # noqa: E501

        a readable name for this entity  # noqa: E501

        :return: The name of this V1NetworkAllocateRequest.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this V1NetworkAllocateRequest.

        a readable name for this entity  # noqa: E501

        :param name: The name of this V1NetworkAllocateRequest.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def nat(self):
        """Gets the nat of this V1NetworkAllocateRequest.  # noqa: E501

        if set to true, packets leaving this network get masqueraded behind interface ip  # noqa: E501

        :return: The nat of this V1NetworkAllocateRequest.  # noqa: E501
        :rtype: bool
        """
        return self._nat

    @nat.setter
    def nat(self, nat):
        """Sets the nat of this V1NetworkAllocateRequest.

        if set to true, packets leaving this network get masqueraded behind interface ip  # noqa: E501

        :param nat: The nat of this V1NetworkAllocateRequest.  # noqa: E501
        :type: bool
        """

        self._nat = nat

    @property
    def parentnetworkid(self):
        """Gets the parentnetworkid of this V1NetworkAllocateRequest.  # noqa: E501

        the parent network from which this network should be allocated  # noqa: E501

        :return: The parentnetworkid of this V1NetworkAllocateRequest.  # noqa: E501
        :rtype: str
        """
        return self._parentnetworkid

    @parentnetworkid.setter
    def parentnetworkid(self, parentnetworkid):
        """Sets the parentnetworkid of this V1NetworkAllocateRequest.

        the parent network from which this network should be allocated  # noqa: E501

        :param parentnetworkid: The parentnetworkid of this V1NetworkAllocateRequest.  # noqa: E501
        :type: str
        """
        if parentnetworkid is None:
            raise ValueError("Invalid value for `parentnetworkid`, must not be `None`")  # noqa: E501

        self._parentnetworkid = parentnetworkid

    @property
    def partitionid(self):
        """Gets the partitionid of this V1NetworkAllocateRequest.  # noqa: E501

        the partition this network belongs to  # noqa: E501

        :return: The partitionid of this V1NetworkAllocateRequest.  # noqa: E501
        :rtype: str
        """
        return self._partitionid

    @partitionid.setter
    def partitionid(self, partitionid):
        """Sets the partitionid of this V1NetworkAllocateRequest.

        the partition this network belongs to  # noqa: E501

        :param partitionid: The partitionid of this V1NetworkAllocateRequest.  # noqa: E501
        :type: str
        """

        self._partitionid = partitionid

    @property
    def projectid(self):
        """Gets the projectid of this V1NetworkAllocateRequest.  # noqa: E501

        the project id this network belongs to, can be empty if globally available  # noqa: E501

        :return: The projectid of this V1NetworkAllocateRequest.  # noqa: E501
        :rtype: str
        """
        return self._projectid

    @projectid.setter
    def projectid(self, projectid):
        """Sets the projectid of this V1NetworkAllocateRequest.

        the project id this network belongs to, can be empty if globally available  # noqa: E501

        :param projectid: The projectid of this V1NetworkAllocateRequest.  # noqa: E501
        :type: str
        """

        self._projectid = projectid

    @property
    def shared(self):
        """Gets the shared of this V1NetworkAllocateRequest.  # noqa: E501

        marks a network as shareable.  # noqa: E501

        :return: The shared of this V1NetworkAllocateRequest.  # noqa: E501
        :rtype: bool
        """
        return self._shared

    @shared.setter
    def shared(self, shared):
        """Sets the shared of this V1NetworkAllocateRequest.

        marks a network as shareable.  # noqa: E501

        :param shared: The shared of this V1NetworkAllocateRequest.  # noqa: E501
        :type: bool
        """

        self._shared = shared

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(V1NetworkAllocateRequest, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, V1NetworkAllocateRequest):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
